import { HttpServerRequest, HttpResponse, HttpRequest } from "@reactive-js/http";
import { ObservableLike } from "@reactive-js/observable";
import { DisposableLike } from "@reactive-js/disposable";
export declare type HttpServer<TReq, TResp> = (req: HttpServerRequest<TReq>) => ObservableLike<HttpResponse<TResp>>;
export declare const enum HttpClientRequestStatusType {
    Start = 1,
    Progress = 2,
    Completed = 3,
    HeaderReceived = 4
}
export declare type HttpClientRequestStatusStart = {
    readonly type: HttpClientRequestStatusType.Start;
};
export declare type HttpClientRequestStatusProgress = {
    readonly type: HttpClientRequestStatusType.Progress;
    readonly count: number;
};
export declare type HttpClientRequestStatusComplete = {
    readonly type: HttpClientRequestStatusType.Completed;
};
export declare type HttpClientRequestStatusHeaderReceived<TResp extends DisposableLike> = {
    readonly type: HttpClientRequestStatusType.HeaderReceived;
    readonly response: HttpResponse<TResp>;
};
export declare type HttpClientRequestStatus<TResp extends DisposableLike> = HttpClientRequestStatusStart | HttpClientRequestStatusProgress | HttpClientRequestStatusComplete | HttpClientRequestStatusHeaderReceived<TResp>;
export declare type HttpClient<THttpRequest extends HttpRequest<unknown>, TResp extends DisposableLike> = (req: THttpRequest) => ObservableLike<HttpClientRequestStatus<TResp>>;
//# sourceMappingURL=index.d.ts.map